/*Copyright (C) 2019 Centro de Computacao Cientifica e Software Livre
Departamento de Informatica - Universidade Federal do Parana

This file is part of Plataforma Integrada MEC.

Plataforma Integrada MEC is free software: you can redistribute it and/or modify
it under the terms of the GNU Affero General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

Plataforma Integrada MEC is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU Affero General Public License for more details.

You should have received a copy of the GNU Affero General Public License
along with Plataforma Integrada MEC.  If not, see <http://www.gnu.org/licenses/>.*/

import React, {useState, useEffect} from 'react'
import PanelTemplateRede from '../PanelComponents/TemplateRede.js'
import {fetchAllRequest} from '../../HelperFunctions/getAxiosConfig'

export default function TabRede (props) {
    const [followers, setFollowers] = useState([])
    const [followersSlice, setFollowersSlice] = useState([])

    const showMoreFollowers = () => {
        let varSlice = followersSlice.length
        setFollowersSlice(followers.slice(0, varSlice + 4))
    }
    const showAllFollowers = () => {setFollowersSlice(followers)}

    const [following, setFollowing] = useState([])
    const [followingSlice, setFollowingSlice] = useState([])
    const showMoreFollowing = () => {
        let varSlice = followingSlice.length
        setFollowingSlice(following.slice(0, varSlice + 4))
    }
    const showAllFollowing = () => {setFollowingSlice(following)}

    function handleSuccess (responseArr) {
        setFollowers(responseArr[0])
        setFollowersSlice(responseArr[0].slice(0,4))

        setFollowing(responseArr[1])
        setFollowingSlice(responseArr[1].slice(0,4))
    }

    useEffect( () => {

        const urls = [`/users/${props.id}/followers`, `/users/${props.id}/following/User`]

        fetchAllRequest(urls, handleSuccess, (error) => {console.log(error)})
    }, [])

    return (
        <React.Fragment>
            <PanelTemplateRede
                title={"Seguidores"}
                length={followers.length}
                sliceArr={followersSlice}
                showMore={showMoreFollowers}
                showAll={showAllFollowers}
                follower={true}
                noContentText={props.username + ' não possui nenhum seguidor'}
            />

        <PanelTemplateRede
                title={"Seguindo"}
                length={following.length}
                sliceArr={followingSlice}
                showMore={showMoreFollowing}
                showAll={showAllFollowing}
                follower={false}
                noContentText={props.username + ' não segue nenhum usuário'}
            />
        </React.Fragment>
    )
}
